from core.core00_core_model.mixin.base_mixin import BaseMixinsNoJoin
from core.core00_core_model.concept.timed import utcnow

from sqlalchemy import Column, Integer, DateTime, String
from sqlalchemy.orm import Mapped, mapped_column
from datetime import datetime


class LocalSSTICContext(*BaseMixinsNoJoin):

    __tablename__ = 'local_sstic_target_context'

    id: Mapped[int] = mapped_column(Integer, primary_key=True)
    instance_id: Mapped[str] = mapped_column(String, nullable=False)
    ip: Mapped[str] = mapped_column(String, nullable=True)
    port: Mapped[int] = Column(Integer)
    step: Mapped[str] = Column(String, nullable=False)

    created_at: Mapped[datetime] = Column(DateTime(timezone=True), server_default=utcnow())

    def __repr__(self):
        return f"[.] Local exec context for {self.step} (instance ID {self.instance_id}) created at {self.created_at}"
