from step1_utils_interact import InteractHandler
from step1_model import receive_message

import asyncio


async def on_recv(full_context, data, serverside_writer, serverside_reader, clientside_writer=None,
                  clientside_reader=None):
    receive_message(data, True, full_context)
    serverside_writer.write(data)
    await serverside_writer.drain()
    if not (server_to_client := (await serverside_reader.read(1024))):
        print("Connection closed by server")
        return
    receive_message(server_to_client, False, full_context)
    return server_to_client


if __name__ == '__main__':
    asyncio.run(InteractHandler(on_recv).main_loop())
