from utils.protocol import ObjectType, FacingDirection
from utils.recv_thread import Loop

import time


# we wait for all objects being there to avoid lacking heap control
def wait_for_all_objects(ctxt):
    print("[.] Waiting for three objects being populated")
    ctxt['loop'].wait_for('n_objects')
    while ctxt['n_objects'] < 3:
        time.sleep(0.1)
    print("[+] Three objects are populated")

# waits for all objects being populated and returns the cristal
def wait_for_all_objects_and_find_cristal(ctxt):
    wait_for_all_objects(ctxt)
    for object in ctxt['objects']:
        if object.object_type == ObjectType.Greenshard:
            ctxt['greenshard'] = object
    print(f"[+] Cristal found: {ctxt['greenshard']}")

# now that we know where the cristal is, we must push the player on the cristal
def push_target_on_player(ctxt):
    all_players = ctxt.get('all_players', {})
    target_id = ctxt.get('target_player', 0)
    target_player = all_players.get(target_id, None)
    if not target_player:
        print("[-] Hmm bad thing no target player")
        return

    cristal_absolute = ctxt['greenshard'].pos_x
    current_pos = ctxt['all_players'][target_id].x // 30
    if ctxt['all_players'][target_id].map_id == 1:
        ctxt['push_direction'] = FacingDirection.Left if current_pos > cristal_absolute else FacingDirection.Right
    else:
        ctxt['push_direction'] = FacingDirection.Left if ctxt['all_players'][target_id].map_id == 0 else FacingDirection.Right
    l = ctxt['loop']
    l.set_position(ctxt['push_direction'], 500, 388)

    def push_check_loop():
        l.launch_attack(target_id, 0)
        time.sleep(0.2)

    print("[+] Start pushing >>>")
    while ctxt['n_objects'] == 3:
        push_check_loop()
    print("[.] >>> Get the cristal, wait for a new one >>>")
    print(target_player)


# at last push the player off the screen
def push_outside(ctxt):
    l = ctxt['loop']
    while ctxt['all_players'][ctxt['target_player']].map_id == 1:
        l.launch_attack(ctxt['target_player'], 0)
        time.sleep(0.2)
    print("[+] >>> OUT! Stop pushing")


def force_player_take_cristal_and_push_it(ctxt):
    wait_for_all_objects_and_find_cristal(ctxt)
    push_target_on_player(ctxt)
    wait_for_all_objects(ctxt)
    push_outside(ctxt)
    print("[.] My job is done here, merci captain pusher")


if __name__ == '__main__':
    print("[+] Input for player to join, and force player taking cristal under his behalf")
    input()

    l = Loop()
    target_id = l.wait_for('target_player')
    force_player_take_cristal_and_push_it(l.context)

    time.sleep(0.8)
    l.disconnect()
    time.sleep(0.3)
    l.end()
