from core.core05_persistent_model.policy.session import get_session

from wussticcommon.model.reverse_port_forward import get_reverse_port_forward_manager
import wussticcommon.interact.target_choice  # current sstic step
from server.api.api import app

import uvicorn


if __name__ == "__main__":
    with get_session():
        rpfm = get_reverse_port_forward_manager()
        with rpfm.with_ssh_forward() as fwd:
            LOCAL_HOST = '127.0.0.1'
            LOCAL_PORT = fwd.listen_port
            PUBLIC_URL = f"http://{rpfm.rpf.remote_ip}:{rpfm.rpf.remote_port}"
            print(LOCAL_HOST, LOCAL_PORT)
            uvicorn.run('main:app', host=LOCAL_HOST, port=LOCAL_PORT, reload=True, workers=2)
