from core.core00_core_model.mixin.base_mixin import BaseMixinsNoJoin
from core.core00_core_model.concept.timed import utcnow

from sqlalchemy import Integer, DateTime, Text
from sqlalchemy.orm import Mapped, mapped_column
from datetime import datetime


class Error(*BaseMixinsNoJoin):

    __tablename__ = 'error'

    id: Mapped[int] = mapped_column(Integer, primary_key=True)
    error: Mapped[str] = mapped_column(Text)

    created_at: Mapped[datetime] = mapped_column(DateTime(timezone=True), server_default=utcnow())

    def __repr__(self):
        return f"[{self.created_at}] Error log {self.error}"
