from core.core00_core_model.mixin.base_mixin import BaseMixinsNoJoin
from core.core00_core_model.concept.timed import CreatedAt

from .read_query import ReadQuery

from sqlalchemy import Integer, BINARY, ForeignKey
from sqlalchemy.orm import relationship, mapped_column, Mapped


class ReadQueryAnswer(*BaseMixinsNoJoin, CreatedAt):

    __tablename__ = 'ReadQueryAnswer'

    id: Mapped[int] = mapped_column(Integer, primary_key=True)
    query_id: Mapped[int] = mapped_column(Integer, ForeignKey(ReadQuery.id), unique=True)
    content: Mapped[bytes] = mapped_column(BINARY)

    read_query: Mapped[ReadQuery] = relationship(ReadQuery, foreign_keys=[query_id], back_populates='answer')

    def __repr__(self):
        return f"Answer to [{self.read_query}]: {self.content.hex()}"
