from core.core00_core_model.mixin.base_mixin import BaseMixinsNoJoin
from core.core00_core_model.concept.timed import CreatedAt

from .write_query import WriteQuery

from sqlalchemy.orm import relationship, Mapped, mapped_column
from sqlalchemy import Integer, ForeignKey, String


class WriteQueryAnswer(*BaseMixinsNoJoin, CreatedAt):

    __tablename__ = 'WriteQueryAnswer'

    id: Mapped[int] = mapped_column(Integer, primary_key=True)
    query_id: Mapped[int] = mapped_column(Integer, ForeignKey(WriteQuery.id), unique=True)
    status: Mapped[str] = mapped_column(String)

    write_query: Mapped[WriteQuery] = relationship(WriteQuery, foreign_keys=[query_id], back_populates='answer')


    def __repr__(self):
        return f"Answer to [{self.write_query}]: {self.status}"
