from core.core05_persistent_model.policy.session import get_session
from core.core10_parsing.cli.registry import register_simple_parsing
from core.core31_policy.entrypoint.entrypoint import defaul_cli_init
from core.core02_model.typed.file import FileContent

from utils.upload import upload_data


arguments = [
    (['--up-source', '-ups'], {'help': 'Local source file path to upload'}),
    (['--up-name', '-name'], {'help': 'Name of the file to set remotely'}),
]

def execute_from_parsed(parsed):
    with get_session():
        upload_data(FileContent(content=open(parsed.up_source, 'rb').read()),
                    filename=parsed.up_name if parsed.up_name else parsed.up_source)

register_simple_parsing('upload', arguments=arguments, callback_after_parsing=execute_from_parsed)


if __name__ == '__main__':
    defaul_cli_init()
