#include "csr.h"

#ifndef DISABLE_CUSTOM_CSR

#define DEFINE_CSRR(i)                                                         \
  unsigned long csrr_##i() {                                                   \
    unsigned long value;                                                       \
    asm volatile("csrr %0, mkey" #i : "=r"(value));                            \
    return value;                                                              \
  }

#define DEFINE_CSRW(name)                                                      \
  void csrw_##name(unsigned long value) {                                      \
    asm volatile("csrw " #name ", %0" : : "r"(value));                         \
  }

#else

#define DEFINE_CSRR(i)                                                         \
  unsigned long csrr_##i() { return 'R' << 24 | 'E' << 16 | 'D' << 8 | 'A'; }

#define DEFINE_CSRW(name)                                                      \
  void csrw_##name(__attribute__((unused)) unsigned long value) {}

#endif

DEFINE_CSRR(0)
DEFINE_CSRR(1)
DEFINE_CSRR(2)
DEFINE_CSRR(3)
DEFINE_CSRR(4)
DEFINE_CSRR(5)
DEFINE_CSRR(6)
DEFINE_CSRR(7)
unsigned long (*csrr[8])(void) = {
    csrr_0, csrr_1, csrr_2, csrr_3, csrr_4, csrr_5, csrr_6, csrr_7,
};

DEFINE_CSRW(mafia_0)
DEFINE_CSRW(mafia_1)
DEFINE_CSRW(mafia_1_now)
