from core.core05_persistent_model.policy.session import get_session

from step1_model import UnitCryptoMessageModel, UnitErrorMessageModel, \
    get_all_unknown_messages_with_answers, get_all_known_messages_with_answers, refresh_decrypted
from step1_exploit import OrderedMessages, decrypt_and_act


def deal_with(msg_index, msg, known):
    match msg:
        case UnitCryptoMessageModel():
            data = bytes.fromhex(msg.enc_bytes)[1:]
            out = decrypt_and_act(msg_index, data, 0)

            msg_type = out[8]
            if msg_type not in known:
                known.add(msg_type)
                print(f"{msg_type} not known, will do all msg")
                for block_idx in range(1, (len(data) // 0x10) - 1):
                    decrypt_and_act(msg_index, data, block_idx)
        case UnitErrorMessageModel():
            print("Error message so no analysis")
        case _:
            raise NotImplementedError


if __name__ == '__main__':

    with get_session():
        all_decrypted_messages = refresh_decrypted()
        all_unknown_messages = get_all_unknown_messages_with_answers()
        all_known_messages = get_all_known_messages_with_answers()

    om = OrderedMessages(all_known_messages, all_unknown_messages)
    known = set([bytes.fromhex(dm.decrypted)[8] for dm in all_decrypted_messages.values()])
    for msg_index, msg in om.order_messages():
        if msg.to_server and (msg.length - 1) % 16 == 0:
            print(f"ASKED {msg_index}, {msg}, known is {known}")
            deal_with(msg_index, msg, known)
