from core.core05_persistent_model.policy.session import get_session

from step1_model import refresh_decrypted, get_all_unknown_messages_with_answers, \
    get_all_known_messages_with_answers
from step1_clientoracle import deal_with, on_recv
from step1_utils_interact import InteractHandler
from step1_exploit import OrderedMessages

from threading import Thread
import asyncio


if __name__ == '__main__':

    with get_session():
        all_decrypted_messages = refresh_decrypted()
        all_unknown_messages = get_all_unknown_messages_with_answers()
        all_known_messages = get_all_known_messages_with_answers()

    om = OrderedMessages(all_known_messages, all_unknown_messages)
    known = set()


    def doit():
        for msg_index, msg in om.order_messages():
            if not msg.to_server and (msg.length - 1) % 16 == 0:
                print(f"ASKED {msg_index}, {msg}, known is {known}")
                deal_with(msg_index, msg, known)

    decrypt_thread = Thread(target=doit)
    decrypt_thread.start()

    ih = InteractHandler(on_recv)
    asyncio.run(ih.main_loop())

    decrypt_thread.join()
