from core.core02_model.typed.file import FileContent
from core.core30_context.context_dependency_graph import context_producer, context_dependencies
from core.core11_config.config import Config, config_dependencies
from core.core30_context.context import Context

from action.utils.local_state import Store

from ..utils.upload import upload_data
from ..utils.manage import Shell

import datetime
import os


basename = os.path.dirname(__file__)


@context_producer(('.systemctxt.script_result', str))
@context_dependencies(('.systemctxt.execute_shell', Shell), ('.state.store', Store))
@config_dependencies(('.systemctxt.pwn_script', str))
def execute_script(config: Config, ctxt: Context, *args):
    content = open(os.path.join(basename, 'scripts', config['systemctxt']['pwn_script']), 'rb').read()
    fname = config['systemctxt']['pwn_script'].replace('.py', '') + '-' + \
            datetime.datetime.now().strftime("%Y-%m-%d_%H-%M-%S") + '.py'

    upload_data(FileContent(content=content), fname)
    command = f"python {fname} {' '.join(map(str, args))}"
    out = ctxt['systemctxt']['execute_shell'].execute(command, 200)
    current_store = ctxt['state']['store']
    current_store[fname] = out.decode()
    ctxt['systemctxt']['script_result'] = current_store[fname]
    return current_store[fname]
